/* sf33d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__33 = 33;

/* Subroutine */ int sf33d_c(doublereal *x, integer *n, integer *nmax,
        doublereal *fun1, doublereal *fun2, doublereal *work, integer *ierr)
{
    /* Initialized data */

    static doublereal sys001 = 3.141592653589793;
    static doublereal sys039 = .5772156649015329;

    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1;

    /* Builtin functions */
    double log(doublereal), sqrt(doublereal), sin(doublereal),
            cos(doublereal);

    /* Local variables */
    static integer i__, j, k;
    static doublereal p, r__, u, v;
    extern /* Subroutine */ int utsf11_c(integer *, integer *);
    static integer n1, n2;
    static doublereal p0, p1, q0, q1, q2, r1, r2, r3, r4, r5, u1, u2, u3, u4, 
            u5, v1, v2, v3, v4, v5, v6, v7;
    static integer na, nb;
    static doublereal pi;
    static integer nc1, nc2;

    /* Parameter adjustments */
    --work;
    --fun2;
    --fun1;

    /* Function Body */
    if (*n < 2) {
        goto L27;
    }
/* Computing MAX */
    i__1 = *n, i__2 = ((integer) ((real) (*x)) << 1) + 4;
    nc1 = max(i__1,i__2);
    if (*nmax < nc1) {
        goto L29;
    }
    *ierr = 0;
    pi = sys001;
    if (*x <= 0.) {
        goto L1;
    } else {
        goto L2;
    }
L1:
    *ierr = 67;
    goto L28;
L2:
/* Computing MAX */
    d__1 = *x + 1.;
    nc1 = (integer) ((real) max(d__1,3.));
    nc2 = (nc1 << 1) + 1;
    if (*n - nc1 <= 0) {
        goto L3;
    } else {
        goto L4;
    }
L3:
    n2 = *n;
    n1 = *n;
    goto L7;
L4:
    n1 = nc1;
    if (*n - nc2 <= 0) {
        goto L5;
    } else {
        goto L6;
    }
L5:
    n2 = nc2 + 1;
    goto L7;
L6:
    n2 = *n;
L7:
    if (*x >= 10.) {
        goto L14;
    }
    if (*x > 1.) {
        goto L12;
    }
    r1 = *x * .5f;
/* Computing 2nd power */
    d__1 = r1;
    r2 = -(d__1 * d__1);
    u1 = 1.;
    u2 = 1.;
    u3 = 1.;
    u4 = 1.;
    p0 = 1.;
    p1 = 1.;
    q0 = -(log(r1) + sys039);
    v1 = q0;
    q1 = v1 + .5;
    v2 = q1;
    for (i__ = 1; i__ <= 10; ++i__) {
        u1 = u1 * r2 / (doublereal) ((*n - 1 + i__) * i__);
        p0 += u1;
        u2 = u2 * r2 / (doublereal) ((*n - 2 + i__) * i__);
        p1 += u2;
        r3 = 1. / (doublereal) i__;
        r4 = 1. / (doublereal) (i__ + 1);
/* Computing 2nd power */
        d__1 = r3;
        u3 = u3 * r2 * (d__1 * d__1);
        v1 += r3;
        q0 += u3 * v1;
        u4 = u4 * r2 * r3 * r4;
        v2 += (r3 + r4) * .5f;
        q1 += u4 * v2;
/* L8: */
    }
    fun1[*n] = p0;
    fun1[*n - 1] = p1;
    r3 = -.6366197723675813;
    fun2[1] = r3 * q0;
    fun2[2] = r3 * (1. - r2 * 2. * q1);
    if (*n == 2) {
        goto L11;
    }
    fun2[3] = fun2[2] + r2 * fun2[1] * 2.;
    i__1 = *n;
    for (i__ = 4; i__ <= i__1; ++i__) {
        fun2[i__] = fun2[i__ - 1] + fun2[i__ - 2] * r2 /
                (doublereal) ((i__ - 2) * (i__ - 3));
/* L9: */
    }
    na = *n - 2;
    i__1 = na;
    for (j = 1; j <= i__1; ++j) {
        i__ = na - j + 1;
        fun1[i__] = fun1[i__ + 1] + fun1[i__ + 2] * r2 /
                (doublereal) (i__ * (i__ + 1));
/* L10: */
    }
L11:
    goto L31;
L12:
    r1 = *x * .5;
/* Computing 2nd power */
    d__1 = r1;
    r2 = -(d__1 * d__1);
    u1 = 1.;
    u2 = 1.;
    p0 = 1.;
    p1 = 1.;
    q0 = -(log(r1) + sys039);
    v1 = q0;
    q1 = v1 + .5;
    v2 = q1;
    for (i__ = 1; i__ <= 27; ++i__) {
        r3 = 1. / (doublereal) i__;
        r4 = 1. / (doublereal) (i__ + 1);
/* Computing 2nd power */
        d__1 = r3;
        u1 = u1 * r2 * (d__1 * d__1);
        p0 += u1;
        v1 += r3;
        q0 += u1 * v1;
        u2 = u2 * r2 * r3 * r4;
        p1 += u2;
        v2 += (r3 + r4) * .5;
        q1 += u2 * v2;
/* L13: */
    }
    fun1[1] = p0;
    fun1[2] = r1 * p1;
    r2 = -2. / pi;
    fun2[1] = r2 * q0;
    fun2[2] = (.5 / r1 + r1 * q1) * r2;
    goto L16;
L14:
    r1 = .125 / *x;
/* Computing 2nd power */
    d__1 = r1;
    r2 = -(d__1 * d__1);
    p0 = 1.;
    q0 = 1.;
    p1 = 1.;
    q1 = 1.;
    u1 = 1.;
    u2 = 1.;
    u3 = 1.;
    u4 = 1.;
    for (i__ = 1; i__ <= 12; ++i__) {
        v1 = (real) i__ * 2.;
        v2 = v1 * 2.;
/* Computing 2nd power */
        d__1 = (v2 - 3.) * (v2 - 1.);
        v3 = d__1 * d__1;
/* Computing 2nd power */
        d__1 = v2;
        v4 = d__1 * d__1 - 1.;
        v5 = v4 * (v2 - 3.);
        v6 = v5 * (v2 + 3.);
        v5 *= v2 - 5.;
/* Computing 2nd power */
        d__1 = v4;
        v4 = d__1 * d__1;
        v7 = r2 / ((v1 - 1.) * v1);
        u1 = u1 * v3 * v7;
        p0 += u1;
        v2 = r2 / ((v1 + 1.) * v1);
        u2 = u2 * v4 * v2;
        q0 += u2;
        u3 = u3 * v5 * v7;
        p1 += u3;
        u4 = u4 * v6 * v2;
        q1 += u4;
/* L15: */
    }
    q0 = r1 * q0;
    q1 = r1 * 3. * q1;
    u1 = pi / 2.;
    u2 = sqrt(u1 * *x);
    u3 = *x + u1 * .5;
    u4 = sin(u3) / u2;
    u5 = cos(u3) / u2;
    fun1[1] = p0 * u4 - q0 * u5;
    fun1[2] = q1 * u4 - p1 * u5;
    fun2[1] = -(p0 * u5 + q0 * u4);
    fun2[2] = -(p1 * u4 + q1 * u5);
L16:
    r1 = 2. / *x;
    i__1 = n1;
    for (i__ = 3; i__ <= i__1; ++i__) {
        r2 = r1 * (doublereal) (i__ - 2);
        fun1[i__] = r2 * fun1[i__ - 1] - fun1[i__ - 2];
        fun2[i__] = r2 * fun2[i__ - 1] - fun2[i__ - 2];
/* L17: */
    }
    if (n1 == *n) {
        goto L31;
    }
    r1 = *x * .5;
/* Computing 2nd power */
    d__1 = r1;
    r2 = d__1 * d__1;
    q2 = 1.;
    u = 1.;
    v = 1.;
    r3 = r1;
    na = n2 - 2;
    i__1 = na;
    for (i__ = 1; i__ <= i__1; ++i__) {
        v += 1. / (doublereal) (i__ + 1);
        u = u * r2 / (doublereal) (i__ * (na + 1 - i__));
        q2 += u;
        r3 = r3 * r1 / (real) i__;
/* L18: */
    }
    u = 1.;
    p = 1.;
    r2 = -r2;
    if (*x - 10. >= 0.) {
        goto L20;
    } else {
        goto L19;
    }
L19:
    k = 29;
    goto L23;
L20:
    if (*x - 25. >= 0.) {
        goto L22;
    } else {
        goto L21;
    }
L21:
    k = ((integer) ((real) (*x)) << 2) + 1;
    goto L23;
L22:
    k = nc2 - 1;
L23:
    q1 = v * .5 - log(r1) - sys039;
    v = q1;
    i__1 = k;
    for (i__ = 1; i__ <= i__1; ++i__) {
        r4 = 1. / (doublereal) i__;
        r5 = 1. / (doublereal) (n2 - 1 + i__);
        u = u * r2 * r4 * r5;
        p += u;
        v += (r4 + r5) * .5;
        q1 += u * v;
/* L24: */
    }
    q2 = q2 * .5 / r3;
    r3 /= (doublereal) (n2 - 1);
    p *= r3;
    q1 *= r3;
    r2 = -2. / pi;
    fun1[n2] = p;
    fun2[n2] = r2 * (q1 + q2);
    r__ = 2. / *x;
    work[n1] = 0.;
    na = n1 + 1;
    nb = n2 - 1;
    i__1 = nb;
    for (i__ = na; i__ <= i__1; ++i__) {
        work[i__] = 1. / (r__ * (doublereal) (i__ - 1) - work[i__ - 1]);
        fun1[i__] = work[i__] * fun1[i__ - 1];
        fun2[i__] = work[i__] * fun2[i__ - 1];
/* L25: */
    }
    i__1 = nb;
    for (j = na; j <= i__1; ++j) {
        i__ = na + nb - j;
        fun1[i__] = work[i__] * fun1[i__ + 1] + fun1[i__];
        fun2[i__] = work[i__] * fun2[i__ + 1] + fun2[i__];
/* L26: */
    }
    goto L31;
L27:
    *ierr = 65;
L28:
    utsf11_c(ierr, &c__33);
    goto L31;
L29:
    *ierr = 66;
    goto L28;
L31:
    return 0;
} /* sf33d_c */
